<template lang="pug">
  v-card
    v-card-title Harris Matrix
    v-card-text
      v-btn(@click="generateSVG" :disables="loading") Generate Matrix
      div#matirxcontainer(ref="matrixContainer")
</template>

<script>
import mermaidAPI from "mermaid";
export default {
    name: "matrix",
    data() {
        return {
            loading: false
        };
    },
    created() {
        this.$store.dispatch("getMatrix", this.$route.params.trenchid);
        this.$store.dispatch("getContexts", this.$route.params.trenchid);
        mermaidAPI.initialize({
            startOnLoad: false
        });
    },
    methods: {
        generateSVG: function() {
            let element = this.$refs.matrixContainer;
            var insertSVG = function(svgCode, bindFunctions) {
                element.innerHTML = svgCode;
            };
            mermaidAPI.render("graphDiv", this.graphDefinition, insertSVG);
        }
    },
    computed: {
        matrix() {
            return this.$store.state.matrix.data;
        },
        contexts() {
            return this.$store.state.contexts;
        },
        graphDefinition() {
            // eslint-disable-next-line
            this.loading = true;
            let graph = "graph TD \n";
            // eslint-disable-next-line no-unused-vars
            for (let context of this.matrix) {
                graph = graph + `${context.attributes.above}`;
                graph = graph + " --- ";
                graph = graph + `${context.attributes.below}`;
                graph = graph + "\n";
            }
            // eslint-disable-next-line
            this.loading = false;
            return graph;
        }
    }
};
</script>
